<template>
    <div class="buble-wraper" :class="{
      event: event
    }">
      <template v-if="event">
        <div class="content-text">
            {{ message.text }}
        </div>
        <div class="detail">
            <span class="contetn-time">
                {{ strPad(message.date.getHours()) }}:{{ strPad(message.date.getMinutes()) }}
            </span>
        </div>
        <div class="emotion-block">
          <img src="~@/assets/icons/event.svg"/>
        </div>
      </template>
      <template v-else>
        <div class="content-text">
            {{ message.text }}
        </div>

        <div class="detail">
            <span class="contetn-user" @click="toggleEdit">
                {{ user }}
            </span>

            <span class="contetn-time">
                {{ strPad(message.date.getHours()) }}:{{ strPad(message.date.getMinutes()) }}
            </span>
        </div>

        <div class="input-block" v-if="isEdit">
            <input type="text" v-model="temp"/>
            <div>
                <v-button class="round" :class="{
                    grey: temp == user,
                    green: temp != user
                }" @click="saveName">
                    <img src="~@/assets/icons/ok.svg">
                </v-button>
            </div>
        </div>
        <div class="emotion-block">
            <img src="~@/assets/icons/positive.svg" v-if="message.speachColor==='positive'">
            <img src="~@/assets/icons/negative.svg" v-if="message.speachColor==='negative'">
        </div>
      </template>
    </div>
</template>

<script>
  import VButton from './VButton.vue'
  export default {
    name: 'Buble',
    components: { VButton },
    data () {
      return {
        isEdit: false,
        temp: ''
      }
    },
    computed: {
      event () {
        return this.message.tasks.length > 0
      },
      user () {
        let user = this.$store.getters.getUserById(this.message.user)
        if (user) {
          return user.name
        }
        return `Неизвестный ${this.message.user}`
      }
    },
    props: {
      message: {
        type: Object,
        required: true
      }
    },
    methods: {
      toggleEdit () {
        this.isEdit = !this.isEdit
        if (this.isEdit) {
          this.temp = this.user
        }
      },
      saveName () {
        this.$store.commit('updateUser', {
          id: this.message.user,
          name: this.temp
        })
        this.isEdit = false
      },
      strPad (number) {
        return String(number).padStart(2, '0')
      }
    }
  }
</script>

<style lang="scss">
    .buble-wraper {
      &.event{
        background: #1AD16E;
        .content-text{
          color: white;
        }
        .detail{
          color: white;
        }
      }
        position: relative;

        .emotion-block{
            position: absolute;
            right: -40px;
            top: 10px;
        }

        pointer-events: auto;
        background: #FFFFFF;
        box-shadow: 0px 10px 35px rgba(16, 0, 79, 0.15);
        border-radius: 30px 30px 30px 15px;
        padding: 30px;
        margin-top: 15px;
        .content-text{
            font-family: "Muller";
            font-style: normal;
            font-weight: 500;
            font-size: 14px;
            line-height: 150%;
            color: #000000;
        }

        .detail{
            margin-top: 7px;
            font-style: normal;
            font-weight: normal;
            font-size: 14px;
            line-height: 150%;
            color: #A7A8B3;
            .contetn-user{
                pointer-events: auto;
                border-bottom: 1px dashed #A7A8B3;
                cursor: pointer;
                margin-right: 10px;
            }
        }

        .input-block{
            display: flex;
            justify-content: space-between;
            margin-top: 10px;
            input{
                background: rgba(0, 0, 0, 0.06);
                border-radius: 10px;
                border: none;
                padding: 10px 20px;
                width: 70%;
                font-family: Muller;
                font-style: normal;
                font-weight: 500;
                font-size: 14px;
                line-height: 150%;
                /* identical to box height, or 21px */
                color: #000000;
            }
        }
    }
</style>